    Program f11xnfe

!     F11XNF Example Program Text

!     Mark 24 Release. NAG Copyright 2012.

!     .. Use Statements ..
      Use nag_library, Only: f11xnf, nag_wp
!     .. Implicit None Statement ..
      Implicit None
!     .. Parameters ..
      Integer, Parameter               :: nin = 5, nout = 6
!     .. Local Scalars ..
      Integer                          :: i, ifail, n, nnz
      Character (1)                    :: check, trans
!     .. Local Arrays ..
      Complex (Kind=nag_wp), Allocatable :: a(:), x(:), y(:)
      Integer, Allocatable             :: icol(:), irow(:)
!     .. Executable Statements ..
      Write (nout,*) 'F11XNF Example Program Results'
!     Skip heading in data file
      Read (nin,*)

!     Read order of matrix and number of non-zero entries

      Read (nin,*) n
      Read (nin,*) nnz

      Allocate (a(nnz),x(n),y(n),icol(nnz),irow(nnz))

!     Read the matrix A

      Do i = 1, nnz
        Read (nin,*) a(i), irow(i), icol(i)
      End Do

!     Read the vector x

      Read (nin,*) x(1:n)

!     Calculate matrix-vector product

      trans = 'N'
      check = 'C'

!     ifail: behaviour on error exit
!             =0 for hard exit, =1 for quiet-soft, =-1 for noisy-soft
      ifail = 0
      Call f11xnf(trans,n,nnz,a,irow,icol,check,x,y,ifail)

!     Output results

      Write (nout,*)
      Write (nout,*) ' Matrix-vector product'
      Write (nout,'(1X,''('',E16.4,'','',E16.4,'')'')') y(1:n)

!     Calculate conjugate transposed matrix-vector product

      trans = 'T'
      check = 'N'

      ifail = 0
      Call f11xnf(trans,n,nnz,a,irow,icol,check,x,y,ifail)

!     Output results

      Write (nout,*)
      Write (nout,*) ' Conjugate transposed matrix-vector product'
      Write (nout,'(1X,''('',E16.4,'','',E16.4,'')'')') y(1:n)

    End Program f11xnfe
